package org.jeecg.modules.seal.utils.BlindWatermark;

import org.bytedeco.javacpp.Loader;
import org.bytedeco.opencv.opencv_java;
import org.jeecg.modules.seal.config.ResponseResult;
import org.jeecg.modules.seal.utils.BlindWatermark.converter.Converter;
import org.jeecg.modules.seal.utils.BlindWatermark.converter.DctConverter;
import org.jeecg.modules.seal.utils.BlindWatermark.converter.DftConverter;
import org.jeecg.modules.seal.utils.BlindWatermark.dencoder.Decoder;
import org.jeecg.modules.seal.utils.BlindWatermark.dencoder.Encoder;
import org.jeecg.modules.seal.utils.BlindWatermark.dencoder.ImageEncoder;
import org.jeecg.modules.seal.utils.BlindWatermark.dencoder.TextEncoder;

public class Watermark {

   public static String commands = "   commands: \n       encode <option> <original image> <watermark(水印)> <embedded image>\n       decode <option> <original image> <embedded image>\n   encode options: \n       -c discrete cosine transform(离散余弦变换)\n       -f discrete fourier transform (Deprecated)(离散傅里叶变换（已弃用）)\n       -i image watermark(图像水印)\n       -t text  watermark(文本水印)\n   decode options: \n       -c discrete cosine transform(离散余弦变换)\n       -f discrete fourier transform (Deprecated)(离散傅里叶变换（已弃用）)\n   example: \n       encode -ct foo.png test bar.png       decode -c  foo.png bar.png";
   private static final String FOURIER = "f";
   private static final String COSINE = "c";
   private static final String IMAGE = "i";
   private static final String TEXT = "t";


   public static void main(String[] args) throws Exception {
      String option = "-ct";
      String fromPath = "/Users/zymac/Desktop/SealBack/src/main/java/com/upc/sealback/utils/BlindWatermark/1654169865334.png";
      String marks = "";
      String outPath = "/Users/zymac/Desktop/SealBack/src/main/java/com/upc/sealback/utils/BlindWatermark/middle.png";
      Loader.load(opencv_java.class);
      Object converter = null;
      if(option.contains("f")) {
         converter = new DftConverter();
      } else if(option.contains("c")) {
         converter = new DctConverter();
      } else {
         System.out.println(commands);
      }

      Object encoder = null;
      if(option.contains("i")) {
         encoder = new ImageEncoder((Converter)converter);
      } else if(option.contains("t")) {
         encoder = new TextEncoder((Converter)converter);
      } else {
         System.out.println(commands);
      }

      assert encoder != null;

      ((Encoder)encoder).encode(fromPath, marks);
   }

   public static ResponseResult decodeWatermark(String option, String fromPath, String outPath) {
      Loader.load(opencv_java.class);
      Object converter = null;
      if(option.contains("f")) {
         converter = new DftConverter();
      } else if(option.contains("c")) {
         converter = new DctConverter();
      } else {
         System.out.println(commands);
      }

      Decoder decoder = new Decoder((Converter)converter);
      decoder.decode(fromPath, outPath);
      return ResponseResult.getSuccessResult(outPath);
   }

}
